/**
 * 
 * @author Anny Marit Svendsen
 *
 */
public class Beregn {
	
	/**
	 * Beregner cosinus-similariteten mellom to vektorer 
	 * (klyngerepresentant og dokumentvektor) og returnerer 
	 * denne likheten.
	 * 
	 * @param clusterVector	klyngerepresentantvektor
	 * @param docVector		dokumentvektor
	 * @return similariteten som double.
	 */
	public double sim_ij(double[] clusterVector, double[] docVector){
		
		//sim(d_i,d_j) = (sum(w_ki * w_kj)) / square(sum(w_ki)^2 * sum(w_kj)^2)
		//double commonTerms = getSumij(num, weight);		
		// summen av representatntvektor og dokumentvektor / 
		//	rota av ( summen av representantvektor^2 * dokumentvektor^2)
		
		double sum = 0, sum2 = 0, sum3 = 0;
		double sim = 0;
		
		for (int i=0; i<clusterVector.length; i++){
			sum = sum + ( clusterVector[i] * docVector[i]);		
			sum2 = sum2 + ( clusterVector[i] * clusterVector[i]);
			sum3 = sum3 + ( docVector[i] * docVector[i]);
		}
		
		if (sum2!=0 && sum3!=0){
			sim = sum / Math.sqrt(sum2*sum3); //kan ikke dele p 0!!!
		}
		else{
			System.out.println("kunne ikke utfre beregning av sim");
			//dvs. klyngerepr. eller klyngevektor ikke 
			//inneholder noen verdier (alle vektene er 0)
			return 0;
		}
		return sim;	
	}
		
	/**
	 * Beregner den absolutte summen av en vektor og returnerer 
	 * denne som en double.
	 * 
	 * @param 	vector 	vektoren (representert som en matrise) 
	 * 					som det skal beregnes absolutt sum fra.
	 * @return 			den absolutte sum av vektoren.
	 */
	public double sumVect(double[] vector){
		double sum = 0;
		
		for (int i=0; i<vector.length; i++){
			sum = sum + vector[i];
		}	
		return sum;
	}
}
