import javax.swing.*;
import java.io.*;

/**
 * 
 * @author Anny Marit Svendsen
 *
 */
public class FilAapner extends JFileChooser{
   
	private static final long serialVersionUID = 1L;
	private File[] files;
	private File directory;

	/**
	 * Konstruerer et objekt av type JFileChooser som filpningsdialog 
	 * med multiseleksjon aktivert. Man kan velge mellom bde filer og 
	 * kataloger.	
	 */
	public FilAapner(){
		super("..");
		setMultiSelectionEnabled(true);
		setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

		int returnVal = showOpenDialog(null);

		if (returnVal == JFileChooser.APPROVE_OPTION){
			System.out.println("opening files in: " + getCurrentDirectory()+ ".");
			//m sjekke om det er directory eller fil her
			//hvis det er directory skal den ta med filene
			files = getSelectedFiles();
		}
		else {
			System.out.println("Open command cancelled by user.");
		}//endif
	}//end metode FilAapner()



	/**
	 * Konstruerer et objekt av type JFileChooser som fillagringsdialog 
	 * med multiseleksjon deaktivert. Man kan her kun velge kataloger.
	 * 
	 * @param currentDirectory
	 */
	public FilAapner(String currentDirectory){
		super(currentDirectory);
		setMultiSelectionEnabled(false);
		setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

		int returnVal = showSaveDialog(null);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			directory = getSelectedFile();
			System.out.println("filene skal lagres i katalog: "+directory);
		}
		else{
			System.out.println("Save command cancelled by user.");
		}//endif
	}//end metode FilAapner()


	/**
	 * Returnerer matrise som inneholder dokumentfiler.
	 * 
	 * @return matrisa som inneholder filer.
	 */
	public File[] getFiles(){
		return files;
	}//end  metode getFiles()

	/**
	 * Returnerer aktuell katalog.
	 * 
	 * @return filen som angir den aktuelle katalogen.
	 */
	public File getDirectory(){
		return directory;
	}//end metode getDirectory()

}//end klasse FilAapner