import java.util.ArrayList;

/**
 * 
 * @author Anny Marit Svendsen
 *
 */
public class Klynge {

	//id'en til denne klyngen
	private int id = -1;
	//liste over alle nodene i denne klyngen
	private ArrayList<Node> noder = new ArrayList<Node>();
	//nodeMinimum refererer til den noden i denne klyngen som har den minste avstanden til en annen
	private Node nodeMinimum = null;
	
	/**
	 * Konstuerer et objekt av type Klynge med en id.
	 * @param id
	 */
	public Klynge(int id){
		this.id = id;
	}
	
	/**
	 * Returnerer objektet som har minste avstand (best similaritet) til en annen node.
	 * @return objektet med minste avstand i denne klynga til en annen node.
	 */
	public Node getMinimumDistanceNode(){
		return nodeMinimum;
	}
	
	/**
	 * Returnerer id-en til klynga.
	 * @return id-en til klynga.
	 */
	public int getId(){
		return id;
	}
	
	/**
	 * Sletter alle noder i aktuell klynge. Trimmer arraylista med noder.
	 *
	 */
	public void clearNodes(){
		noder.clear();
		noder.trimToSize();
	}
	
	/**
	 * Setter noden med minste avstand (best similaritet) i denne klynga.
	 * 
	 * @param n noden som skal settes til minste avstand (best similaritet) i denne klynga.
	 */
	public void setMinimumDistanceNode(Node n){
		this.nodeMinimum = n;
	}
	
	/**
	 * Legger til en node i listen over noder i klynga.
	 * 
	 * @param n noden som skal legges til i nodelista til klynga.
	 */
	public void addNode(Node n){
		noder.add(n);
	}
	
	/**
	 * Returnerer liste med alle nodene i denne klyngen.
	 * @return liste med alle noder i den bestemte klyngen.
	 */
	public ArrayList getAllNodes(){
		return noder;
	}
}

