
public class Node {
	
	private int id = -1;
	private double[] vector;
	private Node closestNode = null;
	private Klynge closestKlynge = null;
	private double distance = -1;
	
	/**
	 * Konstuerer et objekt av type Node med en id og en vektor. 
	 * Hver node korresponderer til et dokument og vektoren er
	 * termvektoren for dette dokumentet.
	 * 
	 * @param id 		nummer som angir hvilken node det er. 
	 * 					Denne korresponderer med dokumentnumrene.
	 * @param vector	vektoren korresponderende dokument.
	 */
	public Node(int id, double[] vector){
		this.id =  id;
		this.vector = vector;
	}
	
	/**
	 * Returnerer nrmeste klyngenr.
	 * @return nrmeste klynge
	 */
	public Klynge getClosestKlynge(){
		return closestKlynge;
	}
	
	/**
	 * Setter nrmeste klynge.
	 * @param k den klynga med kortest avstand fra denne noden.
	 */
	public void setClosestKlynge(Klynge k){
		this.closestKlynge = k;
	}
	
	/**
	 * Returnerer den noden som har kortest avstand.
	 * @return nrmeste node.
	 */
	public Node getClosestNode() {
		return closestNode;
	}
	
	/**
	 * Setter den noden som har kortest avstand.
	 * @param closest nrmeste node
	 */
	public void setClosestNode(Node closest) {
		this.closestNode = closest;
	}
	
	/**
	 * Returnerer avstand til aktuell klynge
	 * @return avstand til klynge.
	 */
	public double getDistance() {
		return distance;
	}
	
	/**
	 * Setter avstand til klynge.
	 * @param distance avstand til klynge.
	 */
	public void setDistance(double distance) {
		this.distance = distance;
	}
	
	/**
	 * Returnerer det unike nummeret til noden. Dette nummeret
	 * korresponderer med dokumentnr.
	 * @return unikt nummer for hver node.
	 */
	public int getId() {
		return id;
	}
	
	/**
	 * Returnerer vektoren for korresponderende dokument.
	 * @return vektoren for korresponderende dokument.
	 */
	public double[] getVector(){
		return vector;
	}	
}
