import java.awt.*;
import javax.swing.*;

/**
 * 
 * @author Anny Marit Svendsen
 *
 */
public class PaintKmeansResults extends Canvas{

	private static final long serialVersionUID = 1L;
	private int b=800, h=600;
	private int nrOfClusters;
	private JFrame frame;
	private double[][] klynger;
		
	/**
	 * Konstruerer et objekt av type Canvas.
	 * Objekt av type Avstandsberegn blir opprettet.
	 * 
	 */
	public PaintKmeansResults(double[][] klynger, int nrOfClusters){
		this.klynger = klynger;//inneholder: clusterNr, bestSim
		this.nrOfClusters = nrOfClusters;
	}
	
	/**
	 * Tegner opp GUI for grafisk framstilling av sluttresultat 
	 * av klyngeanalysen.
	 * 
	 */
	public void GUI(){
		//oppretter JFrame (selve vinduet)
		frame = new JFrame("Endelig graf for K-means");
		frame.setSize(b,h);
		frame.setResizable(true);
		//frame.setLocationRelativeTo(null);
		frame.setDefaultCloseOperation(2);
		
		//oppretter panel til framen
		JPanel panel = (JPanel)frame.getContentPane();
		panel.add(this);
		panel.setBackground(Color.white);		
		frame.setVisible(true);
	}
	
	/**
	 * Tegner opp endelig grafisk framstilling av K-means.
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.Component#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g){
		System.out.println("repainte");
		b = frame.getWidth();
		h = frame.getHeight();
		int x1,y1,x2,y2;
		
		y1 = h-60;
		for (int i=0; i<klynger.length; i++){
			g.setColor(Color.black);
			
			//marker hvert dokument p x-aksen		
			x1 = ((i+1)*(b/(klynger.length+1)))+10;
			g.fillOval(x1, y1, 7,7);
			
			//tegner opp dokumentnr under x-aksen
			if (klynger.length>20){
				if (i%10 ==0){
					g.drawString(Integer.toString(i),x1, h-40);
				}
			}
			else{
				g.drawString(Integer.toString(i),x1, h-40);
			}
			
			if ((int) klynger[i][0] != -1){
				x2 = x1;		
				//y2 = h- ((int)(klynger[i][0]+1)*(y1/(nrOfClusters+1)));
				y2 = (h-60)- (int)(klynger[i][0]+1)*(y1/(nrOfClusters+1));
				//System.out.println("klynge "+klynger[i][0]+" "+y);
				g.setColor(Color.RED);
				//g.fillOval(x2, y2, 5,5);
				g.drawLine(x1,y1,x2,y2);			
			}
		}
		
		//tegner opp hver klynge som y-akse (bare punkter)
		g.setColor(Color.black);
		for (int i=0; i<nrOfClusters; i++){
			g.fillOval(5, (h-60)- (i+1)*(y1/(nrOfClusters+1)), 7,7);
			//g.drawString(Integer.toString(i),5, h-((i+1)*(y1/(nrOfClusters+1))));
			g.drawString(Integer.toString(i),5, (h-60)- (i+1)*(y1/(nrOfClusters+1)));
		}		
	}    
}
