import javax.swing.*;

import java.awt.*;

public class Painter extends Canvas{
	
	private static final long serialVersionUID = 1L;
	private int x,y;
	private int b=800, h=600;
	private int nrOfClusters;
	private Kmeans k;
	private Avstandsberegn ab;
	private JFrame frame;
	
	/**
	 * Konstruerer et objekt av type Canvas med objekt av type Kmeans.
	 * Objekt av type Avstandsberegn blir opprettet.
	 * 
	 * @param	k	objekt av type K-means
	 */
	public Painter(Kmeans k){
		this.k = k;
		ab = new Avstandsberegn(k);
		nrOfClusters = k.getAntClusters();
	}
	
	/**
	 * Tegner opp GUI for grafisk framstilling av klyngeanalysen.
	 * 
	 */
	public void GUI(){
		//oppretter JFrame (selve vinduet)
		frame = new JFrame("Clustering");
		frame.setSize(b,h);
		frame.setResizable(true);
		frame.setLocationRelativeTo(null);
		frame.setDefaultCloseOperation(2);
		
		//oppretter panel til framen
		JPanel panel = (JPanel)frame.getContentPane();
		panel.add(this);
		panel.setBackground(Color.white);		
		frame.setVisible(true);
	}
    
	/**
	 * Beregner x- og y-koordinater for punktene til
	 * dokumentene. Hvert dokument tilhrer en klynge og blir 
	 * tegnet opp i forhold til denne klyngen. Avstanden inn mot
	 * klyngerepresentanten er relativ i forhold til likheten
	 * mellom de.
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.Component#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g){
		System.out.println("repainte");
		b = frame.getWidth();
		h = frame.getHeight();
		
		//tegner opp klyngerepresentanter
		for (int i=0; i<nrOfClusters; i++){
			g.fillOval((i+1)*(b/(nrOfClusters+1)), h/2, 10,10);
			g.drawString(Integer.toString(i),(i+1)*(b/(nrOfClusters+1)), (h/2)-20);
		}

		ab.clearKlyngeTeller();
		double[][] klynger = k.getKlyngeOversikt();
		ab.setKlyngeOversikt(klynger);
		for (int i=0; i<klynger.length; i++){			
			ab.beregnXogY(i, b, h);
			x = ab.getX();
			y = ab.getY();
			
			//tegner opp hvert objekt, representert som en sirkel
			//med avstand relativ til klyngerepresentanten.
			//farger er annenhver klynge
			if (! (x==-1 && y==-1)){
				if (klynger[i][0]%2==0){
					g.setColor(Color.red);
					g.fillOval(x,y, 8, 8);
				}
				else{
					g.setColor(Color.BLUE);
					g.fillOval(x,y,8,8);
				}
			}
			
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}		
		}	
	}
}
