import java.io.*;

/**
 * 
 * @author Anny Marit Svendsen
 *
 */
public class SkrivTilFil {
	
	private double[][] klyngeoversikt;
	private int antKlynger;
	private File[] files;
	
	/**
	 * Konstruerer et objekt av type SkrivTilFil med klyngeoversikt.
	 * @param klyngeoversikt 	inneholder info om alle klyngene,
	 * 							hvilket klyngenr de tilhrer
	 * 							og similaritet til representant.
	 */
	public SkrivTilFil(double[][] klyngeoversikt, int antKlynger, File[] files){
		this.klyngeoversikt = klyngeoversikt;
		this.antKlynger = antKlynger;
		this.files = files;
	}
	
	/**
	 * Skriver innhold i klyngeoversikt til fil
	 * @throws IOException
	 */
	public void skriv() throws IOException{
		FileWriter fw = new FileWriter(new File("klyngeinfo.inf"));
		BufferedWriter bw = new BufferedWriter(fw);
		
		for (int i=0; i<antKlynger; i++){
			bw.write("Klynge: "+i+"\n");
			int teller = 0;
			for (int j=0; j<klyngeoversikt.length; j++){
				if (klyngeoversikt[j][0]==i){
					String filNavn = files[j].getName();
					filNavn = filNavn.substring(0, filNavn.length()-4);
					if (teller == 7){
						bw.write(filNavn +"\n");
						teller =0;
					}
					else{
						bw.write(filNavn+", ");
						teller++;
					}
				}
			}
			bw.write("\n");
		}
		bw.close();
		fw.close();
	}
}
