import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;
import javax.swing.*;
import javax.swing.event.*;
public class StartKmeans extends JFrame implements ActionListener, ItemListener, ChangeListener, MouseListener{
	
	private static final long serialVersionUID = 1L;
	private JList fileList, repFileList;
	private JButton exitButton;
	private JButton openButton;
	private JButton openRepButton;
	private JButton startButton;
	private File[] files;
	private File[] repFiles;
	private JCheckBox randomCheck;
	private JSlider slider;
	private JLabel antKlyngeFelt;
	private JComboBox weightTypeBox;
	private Weights weightType;
	private int[] randomRepr;
	private JSlider sliderThresh;
	private double threshold=0;
	private JLabel threshLabel;
	
	/**
	 * Konstruerer et objekt av type JFrame.
	 * Kaller opp superklassen JFrame, setter strrelse p vindu 
	 * og lokasjon. Kaller opp gui().
	 *
	 */
	public StartKmeans(){
		super("K-means");
		antKlyngeFelt = new JLabel("Antall klynger: 1", SwingConstants.CENTER);
		antKlyngeFelt.setEnabled(false);
		weightType = Weights.wBoolean;
		setSize(700,500);
		setLocationRelativeTo(null);
		gui();
		setVisible(true);		
	}
	
	/**
	 * Tegner opp GUI for K-means.
	 * 
	 */
	private void gui(){
		Color color = new Color(225,228,255);
		//henter ut panel fra framen
		JPanel panel = (JPanel)this.getContentPane();
		panel.setBorder(BorderFactory.createEmptyBorder(20,15,20,15));
		panel.setBackground(color);
		
		//################## NORTH PANEL #########################################
		JPanel northPanel = new JPanel(new GridLayout(2,1));
		northPanel.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
		northPanel.setBackground(color);
			
			//buttonpanel - knapper for  pne dokumenter (bde vanlige og klyngerepresentanter)
			JPanel buttonPanel = new JPanel(new GridLayout(1,6,5,5));
			buttonPanel.setBackground(color);
			buttonPanel.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
			buttonPanel.setBackground(color);
			openButton = new JButton("pne fil(er)...");
			openButton.addActionListener(this);
			openRepButton = new JButton("pne fil(er)...");
			openRepButton.addActionListener(this);
			buttonPanel.add(openButton);
			buttonPanel.add(new JLabel());
			buttonPanel.add(new JLabel());
			buttonPanel.add(openRepButton);
			buttonPanel.add(new JLabel());
			buttonPanel.add(new JLabel());
			
			JLabel info1 = new JLabel("Velg dokument du nsker  utfre klyngeanalyse p, " +
					"og evt. initielle klyngerepresentanter");
			northPanel.add(info1);
			northPanel.add(buttonPanel);
        
		//################## MAIN PANEL #########################################
		JPanel mainPanel = new JPanel(new GridLayout(1,2,3,0));
		mainPanel.setBackground(color);	
			
			//------- scroller for filListe - dokumenter ------------------------
			fileList = new JList();
			fileList.setFocusable(false);
			fileList.addMouseListener(this);
			fileList.setSelectionBackground(Color.WHITE);
	        fileList.setSelectionForeground(Color.BLACK);
	        JScrollPane fileListScroller = new JScrollPane(fileList, 
	        		JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);   
	        fileListScroller.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
	        		"Dokumenter"));	
			fileListScroller.setBackground(color);
			
			//------- hyreklyngepanel ------------------------------------------
			JPanel rightRepPanel = new JPanel(new BorderLayout());
			//scroller for repfilListe - klyngerepresentanter
			repFileList = new JList();
			repFileList.setFocusable(false);
			repFileList.setSelectionBackground(Color.WHITE);
	        repFileList.setSelectionForeground(Color.BLACK);
	        JScrollPane fileListScroller2 = new JScrollPane(repFileList, 
	        		JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	        fileListScroller2.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
	        		"Klyngerepresentanter"));       
	        fileListScroller2.setBackground(color);
			
			//infohovedpanel
			JPanel infoHovedPanel = new JPanel(new GridLayout(2,1));
			infoHovedPanel.setBackground(color);
			infoHovedPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),
					"Tilfeldig valg av klyngerepresentanter"));		
		        //infopanel
				JPanel infoPanel = new JPanel(new GridLayout(1,2));
				infoPanel.setBackground(color);		
				randomCheck = new JCheckBox("Tilfeldige klyngerepresentanter");
				randomCheck.setBackground(color);
				randomCheck.addItemListener(this);
				randomCheck.setEnabled(false);
				slider = new JSlider(1,11,1);
				slider.setBackground(color);
		        slider.setMajorTickSpacing(2);
		        slider.setMinorTickSpacing(1);
		        slider.setPaintTicks(true);
		        slider.setPaintLabels(true);
		        slider.addChangeListener(this);
		        //slider.setValue(1);
		        slider.setEnabled(false);						
				infoPanel.add(antKlyngeFelt);
				infoPanel.add(slider);
			infoHovedPanel.add(randomCheck);
			infoHovedPanel.add(infoPanel);
		
			rightRepPanel.setBackground(color);
			rightRepPanel.add(fileListScroller2, BorderLayout.CENTER);
			rightRepPanel.add(infoHovedPanel, BorderLayout.SOUTH);
		
		mainPanel.add(fileListScroller);
		mainPanel.add(rightRepPanel);
				
		//################## SOUTH PANEL #########################################
		JPanel southPanel = new JPanel(new BorderLayout());
		southPanel.setBackground(color);
			JPanel southInfo = new JPanel (new GridLayout(1,6,5,5));
			southInfo.setBorder(BorderFactory.createEmptyBorder(10,0,10,0));
			southInfo.setBackground(color);
			JLabel weightInfo = new JLabel("Velg vektingtype:");
			southInfo.add(weightInfo);
			southInfo.add(new JLabel());
			southInfo.add(new JLabel("Angi threshold:"));
			southInfo.add(new JLabel());
			southInfo.add(new JLabel());
			southInfo.add(new JLabel());
			JPanel southChoice = new JPanel(new GridLayout(1,6,5,5));
			southChoice.setBackground(color);
			weightTypeBox = new JComboBox(new Weights[]{Weights.wBoolean, Weights.wFrequency});
			weightTypeBox.addItemListener(this);
			weightTypeBox.setBorder(BorderFactory.createMatteBorder(10,0,10,0, color));
			southChoice.add(weightTypeBox);
			southChoice.add(new JLabel());
			sliderThresh = new JSlider(0,10,0);
			sliderThresh.setBackground(color);
			sliderThresh.setMajorTickSpacing(5);
			sliderThresh.setMinorTickSpacing(1);
			sliderThresh.setPaintTicks(true);
			sliderThresh.setPaintLabels(false);
			sliderThresh.addChangeListener(this);
			southChoice.add(sliderThresh);
			//southChoice.add(new JLabel("[0.0 - 1.0]"));
			threshLabel = new JLabel("0.0");
			southChoice.add(threshLabel);
			southChoice.add(new JLabel());
			southChoice.add(new JLabel());
			JPanel southButtons = new JPanel(new GridLayout(1,6,5,5));
			southButtons.setBackground(color);
			southButtons.add(new JLabel());
			southButtons.add(new JLabel());
			southButtons.add(new JLabel());
			southButtons.add(new JLabel());
			exitButton = new JButton("Avslutt");
			exitButton.addActionListener(this);
			exitButton.setForeground(Color.red);
			startButton = new JButton("Start");
			startButton.addActionListener(this);
			southButtons.add(startButton);
			southButtons.add(exitButton);
		southPanel.add(southInfo, BorderLayout.NORTH);
		southPanel.add(southChoice, BorderLayout.CENTER);
		southPanel.add(southButtons, BorderLayout.SOUTH);
		
		//legger alle panelene til hovedpanelet
		panel.add(northPanel, BorderLayout.NORTH);
		panel.add(mainPanel, BorderLayout.CENTER);
		panel.add(southPanel, BorderLayout.SOUTH);
	}

	/**
	 * Lytter til filpnerknapper for dokumenter og klyngerepresentanter.
	 * Lytter ogs til startknapp for start av klyngeanalyse 
	 * (bare hvis dokumenter og klyngerepresentanter er valgt), og avsluttknapp.
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {	
		if (e.getSource() == openButton){
			FilAapner fc    = new FilAapner();
	        files = fc.getFiles();
	        String currentDirectory = fc.getCurrentDirectory().getAbsolutePath();
	        if (files!=null){
		        System.out.println("current directory: "+currentDirectory);
		        System.out.println(currentDirectory);
		        fileList.setListData(files);
		        randomCheck.setEnabled(true);
	        }
	        else{
	        	System.out.println("matrisa er tom");
	        }//endif
		}
		else if (e.getSource() == openRepButton){
			FilAapner fc = new FilAapner();
			repFiles = fc.getFiles();
			if (repFiles!=null){
				repFileList.setListData(repFiles);
			}
		}
		else if (e.getSource() == startButton){
			System.out.println("start clustering");
			try {
				if(!randomCheck.isSelected()){
					if (files!= null && repFiles!=null){
						if (files.length<repFiles.length){
							//sjekke om ant dokumenter er strre enn antallet klynger
							JOptionPane.showMessageDialog(null, 
									"Du m velge flere dokumenter enn det er klynger", 
									"For f klynger",JOptionPane.INFORMATION_MESSAGE);
						}
						else{
							LagVektorer lag = new LagVektorer(files, repFiles, weightType);
							double[][] vectors = lag.getVectors();
							double[][] repVectors = lag.getRepVectors();
							new Kmeans(vectors, repVectors, threshold, files);
						}		
					}
					else if (files==null){
						JOptionPane.showMessageDialog(null, 
								"Du m velge dokumenter som skal klynges frst", 
								"Ingen dokumenter valgt",JOptionPane.INFORMATION_MESSAGE);
					}
					else{
						JOptionPane.showMessageDialog(null, 
								"Du m velge dokumenter som skal vre klyngerepresentanter frst", 
								"Ingen klyngerepresentanter valgt",JOptionPane.INFORMATION_MESSAGE);
					}
				}
				else if (randomCheck.isSelected()){
					if (files !=null){
						System.out.println("klyngeanalyse med tilfeldige klyngerepr");
						File[] repVectorFiles = new File[randomRepr.length];
						for (int i=0; i<randomRepr.length; i++){
							repVectorFiles[i] = files[randomRepr[i]];
						}
						LagVektorer lag = new LagVektorer(files, repVectorFiles, weightType);
						double[][] vectors = lag.getVectors();
						double[][] repVectors = lag.getRepVectors();
						new Kmeans(vectors, repVectors, threshold, files);
						
					}
					else if (files ==null){
						JOptionPane.showMessageDialog(null, 
								"Du m velge dokumenter som skal klynges frst", 
								"Ingen dokumenter valgt",JOptionPane.INFORMATION_MESSAGE);
					}			
				}
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		else if (e.getSource() == exitButton){
			int exit = JOptionPane.showConfirmDialog(null, 
					"Vil du virkelig avslutte?", "Avslutte", 0, 
					JOptionPane.QUESTION_MESSAGE);
			if (exit==0){
				System.out.println("exit");
				System.exit(0);
			}
		}	
	}
	
	/**
	 * Starter applikasjon for K-means klyngeanalyse.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		try{
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		}
		catch (Exception e){
			System.out.println("setLookAndFeel didn't work! :)");
		}
		new StartKmeans();
	}
	
	/**
	 * Lytter til randomsjekkboksen for tilfeldig valg av klyngerepresentanter
	 * og vektingtypeboksen som angir hvilken vektingtype som skal benyttes.
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.ItemListener#itemStateChanged(java.awt.event.ItemEvent)
	 */
	public void itemStateChanged(ItemEvent e) {
		Object source = e.getItemSelectable();	
		if (source == randomCheck){
			if (e.getStateChange() == ItemEvent.SELECTED){
				System.out.println("automagisk klyngerepr");
				openRepButton.setEnabled(false);
				slider.setEnabled(true);
				repFileList.setEnabled(false);
				antKlyngeFelt.setEnabled(true);
				fileList.setSelectionForeground(Color.red);	
				selectRandomRepr();
			}
			else{
				System.out.println("automagisk klyngerepr. fjernet");
				openRepButton.setEnabled(true);
				slider.setEnabled(false);
				repFileList.setEnabled(true);
				antKlyngeFelt.setEnabled(false);
				fileList.clearSelection();
			}
		}
		else if(source == weightTypeBox){
			System.out.println(((JComboBox) source).getSelectedItem());
			weightType = (Weights) (((JComboBox) source).getSelectedItem());
		}
	}
	
	/**
	 * Lytter til slideren som angir antall tilfeldige klyngerepresentnater
	 * som nskes. Kaller opp metoden selectRandomRepr() dersom verdien i 
	 * slideren forandres.
	 * 
	 *  (non-Javadoc)
	 * @see javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
	 */
	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		//int value = (int)source.getValue();
	    
	    if (!source.getValueIsAdjusting()){
	    	int value = (int)source.getValue();
		    if (source == slider){
	    		System.out.println("verdi: "+value);
	    		antKlyngeFelt.setText("Antall klynger: "+Integer.toString(value));	
	    		//sletter de gamle verdiene som angir hvilke filer som skal vre klyngerepresentanter
	    		randomRepr = null;
	    		selectRandomRepr();
	    	}
		    else if (source == sliderThresh){
				System.out.println("bytter threshold "+value+" double verdi: "+(double)value/10);
				threshold = (double)value/10;
				threshLabel.setText(""+threshold);
			}
	    }		
	}

	/**
	 * Kaller opp metoden selectRandomRepr().
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		selectRandomRepr();	
	}
	
	/**
	 * Kaller opp metoden selectRandomRepr().
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
	 */
	public void mousePressed(MouseEvent e) {
		selectRandomRepr();		
	}
	
	/**
	 * Kaller opp metoden selectRandomRepr().
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {
		selectRandomRepr();	
	}
	
	/**
	 * Kaller opp metoden selectRandomRepr().
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent e) {
		selectRandomRepr();	
	}
	
	/**
	 * Kaller opp metoden selectRandomRepr().
	 * 
	 *  (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent e) {
		selectRandomRepr();
	}
	
	/**
	 * Hvis matrisa som inneholder tilfeldige tall for klyngerepresentanter
	 * er tom s genereres det tilfeldige tall ut fra antallet klyngerepresentanter
	 * som er valgt (i slideren). Hvert tilfeldig tall er unikt, dvs. en fil kan bare 
	 * bli valgt som en klyngerepresentant (ikke flere).
	 * 
	 * Hvis matrisa som skal inneholde tilfeldige tall for klyngerepresentanter 
	 * ikke er tom blir disse markert som rde i fillisten.
	 *
	 */
	private void selectRandomRepr(){
		int randNr = 0; 
		int lengde = 0;
		boolean ikkeFerdig;
		if (randomRepr == null && randomCheck.isSelected()){		
			if (slider.getValue()>=files.length){
				lengde = files.length;
				slider.setValue(lengde);
			}
			else{
				lengde = slider.getValue();	
			}
			randomRepr = new int[lengde];
			for (int i=0; i<lengde; i++){
				randomRepr[i]=-1;
			}
			System.out.println("lengde: "+lengde);

			for (int i=0; i<lengde; i++){
				ikkeFerdig = true;
				while (ikkeFerdig){
					randNr = (int) (Math.random()*(files.length));
					ikkeFerdig = false;
					for (int j=0; j<lengde; j++){
						//System.out.println("randomRepr "+randomRepr[j]);
						if (randomRepr[j] == randNr){
							ikkeFerdig = true;
						}
					}
				}
				randomRepr[i] = randNr;
			}
			fileList.setSelectedIndices(randomRepr);
		}		
		else if( randomRepr != null && randomCheck.isSelected()){
			fileList.setSelectedIndices(randomRepr);
		}
		else if (!randomCheck.isSelected()){
			fileList.clearSelection();
		}
	}	    
}
